class EffectModelWrapper(Module):
  __parameters__ = []
  __buffers__ = ["default_param_values", ]
  default_param_values : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  MAX_N_PARAMS : int
  SDK_VERSION : str
  CURRENT_TIME : float
  use_debug_mode : bool
  neutone_parameters_metadata : Dict[str, Dict[str, str]]
  remapped_params : Dict[str, Tensor]
  in_n_ch : int
  curr_bs : int
  in_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  params_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  model_in_buffer : Tensor
  params_buffer : Tensor
  agg_params : Tensor
  model : __torch__.EffectModel
  def forward(self: __torch__.EffectModelWrapper,
    x: Tensor,
    params: Optional[Tensor]=None) -> Tensor:
    _0 = __torch__.neutone_sdk.utils.validate_waveform
    _1 = "Invalid model input audio length of {} samples, must be of length {} samples"
    _2 = "The model does not support a buffer size of {}"
    _3 = "AssertionError: Model uses a look-behind buffer, but the incoming buffer size has not been set. Be sure to call `set_sample_rate_and_buffer_size` before using the model."
    _4 = "Invalid model output audio length of {} samples, must be of length {} samples (are you using a look behind buffer incorrectly?)"
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _5 = _0(x, (self).is_input_mono(), )
    else:
      pass
    in_n = torch.size(x, 1)
    if torch.__is__(params, None):
      params1 = torch.repeat((self).get_default_param_values(), [1, in_n])
      params0 = params1
    else:
      params0 = unchecked_cast(Tensor, params)
    use_debug_mode0 = self.use_debug_mode
    if use_debug_mode0:
      _6 = torch.size(params0)
      MAX_N_PARAMS = self.MAX_N_PARAMS
      _7 = torch.eq(_6, [MAX_N_PARAMS, in_n])
      if _7:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      curr_bs = self.curr_bs
      if torch.ne(curr_bs, -1):
        curr_bs0 = self.curr_bs
        if torch.eq(in_n, curr_bs0):
          pass
        else:
          curr_bs1 = self.curr_bs
          _8 = torch.format(_1, in_n, curr_bs1)
          _9 = torch.add("AssertionError: ", _8)
          ops.prim.RaiseException(_9)
      else:
        _10 = (self).get_native_buffer_sizes()
        if torch.gt(torch.len(_10), 0):
          _11 = (self).get_native_buffer_sizes()
          if torch.__contains__(_11, in_n):
            pass
          else:
            _12 = torch.add("AssertionError: ", torch.format(_2, in_n))
            ops.prim.RaiseException(_12)
        else:
          pass
      _13 = bool((self).get_look_behind_samples())
      if _13:
        curr_bs2 = self.curr_bs
        if torch.ne(curr_bs2, -1):
          pass
        else:
          ops.prim.RaiseException(_3)
      else:
        pass
    else:
      pass
    _14 = bool((self).get_look_behind_samples())
    if _14:
      in_queue = self.in_queue
      _15 = (in_queue).push(x, )
      params_queue = self.params_queue
      _16 = (params_queue).push(params0, )
      in_queue0 = self.in_queue
      size = in_queue0.size
      model_in_buffer = self.model_in_buffer
      _17 = torch.slice(torch.slice(model_in_buffer), 1, 0, torch.neg(size))
      _18 = torch.tensor(0, dtype=ops.prim.dtype(_17), device=ops.prim.device(_17))
      _19 = torch.copy_(_17, _18)
      in_queue1 = self.in_queue
      model_in_buffer0 = self.model_in_buffer
      _20 = torch.slice(torch.slice(model_in_buffer0), 1, torch.neg(size))
      _21 = (in_queue1).fill(_20, )
      _22 = (self).get_default_param_values()
      params_buffer = self.params_buffer
      _23 = torch.slice(torch.slice(params_buffer), 1, 0, torch.neg(size))
      _24 = torch.copy_(_23, _22)
      params_queue0 = self.params_queue
      params_buffer0 = self.params_buffer
      _25 = torch.slice(torch.slice(params_buffer0), 1, torch.neg(size))
      _26 = (params_queue0).fill(_25, )
      model_in_buffer1 = self.model_in_buffer
      params2, x0 = self.params_buffer, model_in_buffer1
    else:
      params2, x0 = params0, x
    params3 = (self).aggregate_params(params2, )
    use_debug_mode1 = self.use_debug_mode
    if use_debug_mode1:
      if torch.eq(torch.dim(params3), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _27 = torch.size(params3, 0)
      MAX_N_PARAMS0 = self.MAX_N_PARAMS
      if torch.eq(_27, MAX_N_PARAMS0):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    _28 = (self).get_neutone_parameters()
    _29 = [9223372036854775807, torch.len(_28)]
    for idx in range(ops.prim.min(_29)):
      neutone_param = _28[idx]
      _30 = torch.select(params3, 0, idx)
      remapped_params = self.remapped_params
      torch._set_item(remapped_params, (neutone_param)[0], _30)
    remapped_params0 = self.remapped_params
    x1 = (self).do_forward_pass(x0, remapped_params0, )
    use_debug_mode2 = self.use_debug_mode
    if use_debug_mode2:
      _31 = _0(x1, (self).is_output_mono(), )
      curr_bs3 = self.curr_bs
      if torch.eq(curr_bs3, -1):
        _32 = torch.eq(torch.size(x1, 1), in_n)
        if _32:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
      else:
        _33 = torch.size(x1, 1)
        curr_bs4 = self.curr_bs
        if torch.eq(_33, curr_bs4):
          pass
        else:
          _34 = torch.size(x1, 1)
          curr_bs5 = self.curr_bs
          _35 = torch.format(_4, _34, curr_bs5)
          _36 = torch.add("AssertionError: ", _35)
          ops.prim.RaiseException(_36)
    else:
      pass
    return x1
  def calc_model_delay_samples(self: __torch__.EffectModelWrapper) -> int:
    return 0
  def get_core_preserved_attributes(self: __torch__.EffectModelWrapper) -> List[str]:
    _37 = ["model", "default_param_values", "get_default_param_values", "get_default_param_names", "get_default_param_descriptions", "get_default_param_types", "get_default_param_used", "get_wet_default_value", "get_dry_default_value", "get_input_gain_default_value", "get_output_gain_default_value", "get_core_preserved_attributes", "to_core_metadata"]
    return _37
  def get_default_param_descriptions(self: __torch__.EffectModelWrapper) -> List[str]:
    _38 = annotate(List[str], [])
    _39 = (self).get_neutone_parameters()
    for _40 in range(torch.len(_39)):
      x = _39[_40]
      _41 = torch.append(_38, (x)[1])
    return _38
  def get_default_param_names(self: __torch__.EffectModelWrapper) -> List[str]:
    _42 = annotate(List[str], [])
    _43 = (self).get_neutone_parameters()
    for _44 in range(torch.len(_43)):
      x = _43[_44]
      _45 = torch.append(_42, (x)[0])
    return _42
  def get_default_param_types(self: __torch__.EffectModelWrapper) -> List[str]:
    _46 = annotate(List[str], [])
    _47 = (self).get_neutone_parameters()
    for _48 in range(torch.len(_47)):
      x = _47[_48]
      _49 = torch.append(_46, ((x)[3]).value)
    return _46
  def get_default_param_used(self: __torch__.EffectModelWrapper) -> List[bool]:
    _50 = annotate(List[bool], [])
    _51 = (self).get_neutone_parameters()
    for _52 in range(torch.len(_51)):
      x = _51[_52]
      _53 = torch.append(_50, (x)[4])
    return _50
  def get_default_param_values(self: __torch__.EffectModelWrapper) -> Tensor:
    return self.default_param_values
  def get_dry_default_value(self: __torch__.EffectModelWrapper) -> float:
    return 0.
  def get_input_gain_default_value(self: __torch__.EffectModelWrapper) -> float:
    return 0.40000000000000002
  def get_native_buffer_sizes(self: __torch__.EffectModelWrapper) -> List[int]:
    return annotate(List[int], [])
  def get_native_sample_rates(self: __torch__.EffectModelWrapper) -> List[int]:
    return [44100]
  def get_output_gain_default_value(self: __torch__.EffectModelWrapper) -> float:
    return 0.5
  def get_preserved_attributes(self: __torch__.EffectModelWrapper) -> List[str]:
    _54 = "set_daw_sample_rate_and_buffer_size"
    preserved_attrs = (self).get_core_preserved_attributes()
    _55 = ["is_input_mono", "is_output_mono", "get_native_sample_rates", "get_native_buffer_sizes", "is_resampling", "calc_model_delay_samples", "set_sample_rate_and_buffer_size", _54, "reset", "get_preserved_attributes", "to_metadata"]
    torch.extend(preserved_attrs, _55)
    return preserved_attrs
  def get_wet_default_value(self: __torch__.EffectModelWrapper) -> float:
    return 1.
  def is_input_mono(self: __torch__.EffectModelWrapper) -> bool:
    return False
  def is_output_mono(self: __torch__.EffectModelWrapper) -> bool:
    return False
  def is_resampling(self: __torch__.EffectModelWrapper) -> bool:
    return False
  def reset(self: __torch__.EffectModelWrapper) -> bool:
    in_queue = self.in_queue
    _56 = (in_queue).reset()
    params_queue = self.params_queue
    _57 = (params_queue).reset()
    model_in_buffer = self.model_in_buffer
    _58 = torch.fill_(model_in_buffer, 0)
    _59 = (self).get_default_param_values()
    params_buffer = self.params_buffer
    _60 = torch.slice(torch.slice(params_buffer), 1)
    _61 = torch.copy_(_60, _59)
    return (self).reset_model()
  def set_daw_sample_rate_and_buffer_size(self: __torch__.EffectModelWrapper,
    daw_sr: int,
    daw_buffer_size: int,
    model_sr: Optional[int]=None,
    model_buffer_size: Optional[int]=None) -> NoneType:
    _62 = (self).set_sample_rate_and_buffer_size(daw_sr, daw_buffer_size, )
    return None
  def set_sample_rate_and_buffer_size(self: __torch__.EffectModelWrapper,
    sample_rate: int,
    n_samples: int) -> bool:
    _63 = "The model does not support a native buffer size of {}"
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _64 = torch.len((self).get_native_buffer_sizes())
      if torch.gt(_64, 0):
        _65 = (self).get_native_buffer_sizes()
        _66 = torch.__contains__(_65, n_samples)
        if _66:
          pass
        else:
          _67 = torch.add("AssertionError: ", torch.format(_63, n_samples))
          ops.prim.RaiseException(_67)
      else:
        pass
    else:
      pass
    _68 = bool((self).get_look_behind_samples())
    if _68:
      curr_bs = self.curr_bs
      if torch.eq(curr_bs, -1):
        _69 = True
      else:
        curr_bs6 = self.curr_bs
        _69 = torch.ne(n_samples, curr_bs6)
      if _69:
        self.curr_bs = n_samples
        _70 = (self).get_look_behind_samples()
        curr_bs7 = self.curr_bs
        queue_len = torch.add(_70, curr_bs7)
        in_n_ch = self.in_n_ch
        use_debug_mode3 = self.use_debug_mode
        _71 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
        _72 = (_71).__init__(in_n_ch, queue_len, use_debug_mode3, )
        self.in_queue = _71
        MAX_N_PARAMS = self.MAX_N_PARAMS
        use_debug_mode4 = self.use_debug_mode
        _73 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
        _74 = (_73).__init__(MAX_N_PARAMS, queue_len, use_debug_mode4, )
        self.params_queue = _73
        in_n_ch0 = self.in_n_ch
        _75 = torch.zeros([in_n_ch0, queue_len])
        self.model_in_buffer = _75
        _76 = (self).get_default_param_values()
        _77 = torch.repeat(_76, [1, queue_len])
        self.params_buffer = _77
      else:
        pass
    else:
      pass
    _78 = (self).set_model_sample_rate_and_buffer_size(sample_rate, n_samples, )
    return _78
  def to_core_metadata(self: __torch__.EffectModelWrapper) -> __torch__.neutone_sdk.core.CoreMetadata:
    _79 = (self).get_model_name()
    _80 = (self).get_model_authors()
    _81 = (self).get_model_short_description()
    _82 = (self).get_model_long_description()
    neutone_parameters_metadata = self.neutone_parameters_metadata
    _83 = (self).get_wet_default_value()
    _84 = (self).get_dry_default_value()
    _85 = (self).get_input_gain_default_value()
    _86 = (self).get_output_gain_default_value()
    _87 = (self).get_technical_description()
    _88 = (self).get_technical_links()
    _89 = (self).get_tags()
    _90 = (self).get_model_version()
    SDK_VERSION = self.SDK_VERSION
    CURRENT_TIME = self.CURRENT_TIME
    _91 = __torch__.neutone_sdk.core.CoreMetadata(_79, _80, _81, _82, _87, _88, neutone_parameters_metadata, _83, _84, _85, _86, _89, _90, SDK_VERSION, CURRENT_TIME, "1.13.1", (self).get_citation(), (self).is_experimental())
    return _91
  def to_metadata(self: __torch__.EffectModelWrapper) -> __torch__.neutone_sdk.wavform_to_wavform.WaveformToWaveformMetadata:
    core_metadata = (self).to_core_metadata()
    _92 = (core_metadata)[0]
    _93 = (core_metadata)[1]
    _94 = (core_metadata)[2]
    _95 = (core_metadata)[3]
    _96 = (core_metadata)[6]
    _97 = (core_metadata)[7]
    _98 = (core_metadata)[8]
    _99 = (core_metadata)[9]
    _100 = (core_metadata)[10]
    _101 = (core_metadata)[4]
    _102 = (core_metadata)[5]
    _103 = (core_metadata)[11]
    _104 = (core_metadata)[12]
    _105 = (core_metadata)[13]
    _106 = (core_metadata)[15]
    _107 = (core_metadata)[14]
    _108 = (core_metadata)[16]
    _109 = (core_metadata)[17]
    _110 = (self).is_input_mono()
    _111 = (self).is_output_mono()
    if (self).is_input_mono():
      _112 = "mono"
    else:
      _112 = "stereo"
    if (self).is_output_mono():
      _113 = "mono"
    else:
      _113 = "stereo"
    _114 = torch.format("{}-{}", _112, _113)
    _115 = (self).get_native_buffer_sizes()
    _116 = __torch__.neutone_sdk.wavform_to_wavform.WaveformToWaveformMetadata(_92, _93, _104, _94, _95, _101, _102, _103, _108, _109, _96, _97, _98, _99, _100, _110, _111, _114, (self).get_native_sample_rates(), _115, (self).get_look_behind_samples(), _105, _106, _107)
    return _116
  def get_look_behind_samples(self: __torch__.EffectModelWrapper) -> int:
    return 0
  def aggregate_params(self: __torch__.EffectModelWrapper,
    params: Tensor) -> Tensor:
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      if torch.eq(torch.dim(params), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    agg_params = self.agg_params
    _117 = torch.mean(params, [1], True, out=agg_params)
    return self.agg_params
  def get_neutone_parameters(self: __torch__.EffectModelWrapper) -> List[__torch__.neutone_sdk.parameter.NeutoneParameter]:
    _118 = __torch__.neutone_sdk.parameter.NeutoneParameter("lfo_rate", "LFO rate [0.1 to 5 Hz]", 0.20000000000000001, __torch__.neutone_sdk.parameter.NeutoneParameterType.KNOB, True)
    _119 = __torch__.neutone_sdk.parameter.NeutoneParameter("lfo_depth", "LFO depth [0.0, 1.5]", 0.66666665999999997, __torch__.neutone_sdk.parameter.NeutoneParameterType.KNOB, True)
    _120 = __torch__.neutone_sdk.parameter.NeutoneParameter("lfo_stereo_phase_offset", "LFO stereo phase offset [0.0, 2pi]", 0., __torch__.neutone_sdk.parameter.NeutoneParameterType.KNOB, True)
    return [_118, _119, _120]
  def do_forward_pass(self: __torch__.EffectModelWrapper,
    x: Tensor,
    params: Dict[str, Tensor]) -> Tensor:
    _121 = torch.mul(params["lfo_rate"], 4.9000000000000004)
    lfo_rate = torch.add(_121, 0.10000000000000001)
    lfo_depth = torch.mul(params["lfo_depth"], 1.5)
    _122 = torch.mul(params["lfo_stereo_phase_offset"], 2)
    lfo_stereo_phase_offset = torch.mul(_122, 3.1415926535897931)
    x2 = torch.unsqueeze(x, 1)
    model = self.model
    x3 = (model).forward(x2, lfo_rate, lfo_depth, lfo_stereo_phase_offset, )
    return torch.squeeze(x3, 1)
  def reset_model(self: __torch__.EffectModelWrapper) -> bool:
    return False
  def set_model_sample_rate_and_buffer_size(self: __torch__.EffectModelWrapper,
    sample_rate: int,
    n_samples: int) -> bool:
    return False
  def get_model_name(self: __torch__.EffectModelWrapper) -> str:
    return "Melda.phaser_irregular"
  def get_model_authors(self: __torch__.EffectModelWrapper) -> List[str]:
    return ["Christopher Mitcheltree"]
  def get_model_short_description(self: __torch__.EffectModelWrapper) -> str:
    return "LFO extraction evaluation model."
  def get_model_long_description(self: __torch__.EffectModelWrapper) -> str:
    _123 = "LFO extraction evaluation model for \'Modulation Extraction for LFO-driven Audio Effects\'."
    return _123
  def get_technical_description(self: __torch__.EffectModelWrapper) -> str:
    _124 = "Wrapper for a simple conditional LSTM that models phaser, flanger, or chorus effects."
    return _124
  def get_technical_links(self: __torch__.EffectModelWrapper) -> Dict[str, str]:
    _125 = "https://github.com/christhetree/mod_extraction/"
    _126 = {"Paper": "https://arxiv.org/abs/2305.13262", "Code": _125}
    return _126
  def get_tags(self: __torch__.EffectModelWrapper) -> List[str]:
    _127 = ["lfo", "phaser", "flanger", "chorus"]
    return _127
  def get_model_version(self: __torch__.EffectModelWrapper) -> str:
    return "1.0.0"
  def get_citation(self: __torch__.EffectModelWrapper) -> str:
    return ""
  def is_experimental(self: __torch__.EffectModelWrapper) -> bool:
    return True
class EffectModel(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  sr : int
  prev_phase : Tensor
  model : __torch__.mod_extraction.models.LSTMEffectModel
  def forward(self: __torch__.EffectModel,
    x: Tensor,
    lfo_rate: Tensor,
    lfo_depth: Tensor,
    lfo_stereo_phase_offset: Tensor) -> Tensor:
    _128 = torch.size(x, -1)
    _129 = torch.item(lfo_rate)
    prev_phase = self.prev_phase
    _130 = torch.item(prev_phase)
    arg_l = (self).make_argument(_128, float(_129), float(_130), )
    next_phase = torch.remainder(torch.select(arg_l, 0, -1), 6.2831853071795862)
    self.prev_phase = next_phase
    arg_r = torch.add(arg_l, torch.item(lfo_stereo_phase_offset))
    arg = torch.stack([arg_l, arg_r])
    lfo = torch.div(torch.add(torch.cos(arg), 1.), 2.)
    lfo0 = torch.mul_(lfo, lfo_depth)
    lfo1 = torch.unsqueeze(lfo0, 1)
    model = self.model
    return (model).forward(x, lfo1, )
  def make_argument(self: __torch__.EffectModel,
    n_samples: int,
    freq: float,
    phase: float) -> Tensor:
    _131 = torch.mul(torch.full([n_samples], freq), 6.2831853071795862)
    sr = self.sr
    _132 = torch.cumsum(torch.div(_131, sr), 0)
    return torch.add(_132, phase)
