class CircularInplaceTensorQueue:
  use_debug_mode : bool
  max_size : int
  queue : Tensor
  start_idx : int
  end_idx : int
  size : int
  def __init__(self: __torch__.neutone_sdk.queues.CircularInplaceTensorQueue,
    n_ch: int,
    max_size: int,
    use_debug_mode: bool=True) -> NoneType:
    self.use_debug_mode = use_debug_mode
    self.max_size = max_size
    self.queue = torch.zeros([n_ch, max_size])
    self.start_idx = 0
    self.end_idx = 0
    self.size = 0
    return None
  def _calc_pop_indices(self: __torch__.neutone_sdk.queues.CircularInplaceTensorQueue,
    out_n: int) -> Tuple[int, int, int, int]:
    size = self.size
    out_n0 = ops.prim.min(out_n, size)
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      if torch.gt(out_n0, 0):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    start_idx = self.start_idx
    max_size = self.max_size
    if torch.eq(start_idx, max_size):
      start_1 = 0
    else:
      start_1 = start_idx
    end_2 = torch.add(start_1, out_n0)
    max_size0 = self.max_size
    if torch.gt(end_2, max_size0):
      max_size1 = self.max_size
      end_20 = torch.remainder(end_2, max_size1)
    else:
      end_20 = end_2
    if torch.le(end_20, start_1):
      end_1, start_2 = self.max_size, 0
    else:
      end_1, start_2 = end_20, end_20
    return (start_1, end_1, start_2, end_20)
  def _calc_push_indices(self: __torch__.neutone_sdk.queues.CircularInplaceTensorQueue,
    in_n: int) -> Tuple[int, int, int, int]:
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      if torch.lt(0, in_n):
        max_size = self.max_size
        _0 = torch.lt(in_n, max_size)
      else:
        _0 = False
      if _0:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    end_idx = self.end_idx
    max_size2 = self.max_size
    if torch.eq(end_idx, max_size2):
      start_1 = 0
    else:
      start_1 = end_idx
    end_2 = torch.add(start_1, in_n)
    max_size3 = self.max_size
    if torch.gt(end_2, max_size3):
      max_size4 = self.max_size
      end_21 = torch.remainder(end_2, max_size4)
    else:
      end_21 = end_2
    if torch.lt(end_21, start_1):
      end_1, start_2 = self.max_size, 0
    else:
      end_1, start_2 = end_21, end_21
    return (start_1, end_1, start_2, end_21)
  def fill(self: __torch__.neutone_sdk.queues.CircularInplaceTensorQueue,
    out: Tensor) -> int:
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _1 = torch.dim(out)
      queue = self.queue
      if torch.eq(_1, torch.dim(queue)):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _2 = torch.size(out, 0)
      queue0 = self.queue
      _3 = torch.eq(_2, torch.size(queue0, 0))
      if _3:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    if (self).is_empty():
      _4 = 0
    else:
      out_n = torch.size(out, 1)
      if torch.lt(out_n, 1):
        _5 = 0
      else:
        _6 = (self)._calc_pop_indices(out_n, )
        start_1, end_1, start_2, end_2, = _6
        n_1 = torch.sub(end_1, start_1)
        n_2 = torch.sub(end_2, start_2)
        filled_n = torch.add(n_1, n_2)
        use_debug_mode0 = self.use_debug_mode
        if use_debug_mode0:
          if torch.lt(0, n_1):
            size = self.size
            _7 = torch.le(n_1, size)
          else:
            _7 = False
          if _7:
            pass
          else:
            ops.prim.RaiseException("AssertionError: ")
          if torch.le(0, n_2):
            size0 = self.size
            _8 = torch.lt(n_2, size0)
          else:
            _8 = False
          if _8:
            pass
          else:
            ops.prim.RaiseException("AssertionError: ")
          size1 = self.size
          if torch.le(filled_n, size1):
            pass
          else:
            ops.prim.RaiseException("AssertionError: ")
        else:
          pass
        queue1 = self.queue
        _9 = torch.slice(torch.slice(queue1), 1, start_1, end_1)
        _10 = torch.slice(torch.slice(out), 1, 0, n_1)
        _11 = torch.copy_(_10, _9)
        if torch.gt(n_2, 0):
          queue2 = self.queue
          _12 = torch.slice(torch.slice(queue2), 1, start_2, end_2)
          _13 = torch.slice(torch.slice(out), 1, n_1, filled_n)
          _14 = torch.copy_(_13, _12)
        else:
          pass
        _5 = filled_n
      _4 = _5
    return _4
  def is_empty(self: __torch__.neutone_sdk.queues.CircularInplaceTensorQueue) -> bool:
    size = self.size
    return torch.eq(size, 0)
  def is_full(self: __torch__.neutone_sdk.queues.CircularInplaceTensorQueue) -> bool:
    size = self.size
    max_size = self.max_size
    return torch.eq(size, max_size)
  def pop(self: __torch__.neutone_sdk.queues.CircularInplaceTensorQueue,
    out: Tensor) -> int:
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _15 = torch.dim(out)
      queue = self.queue
      if torch.eq(_15, torch.dim(queue)):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _16 = torch.size(out, 0)
      queue3 = self.queue
      _17 = torch.eq(_16, torch.size(queue3, 0))
      if _17:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    if (self).is_empty():
      _18 = 0
    else:
      out_n = torch.size(out, 1)
      if torch.lt(out_n, 1):
        _19 = 0
      else:
        _20 = (self)._calc_pop_indices(out_n, )
        start_1, end_1, start_2, end_2, = _20
        n_1 = torch.sub(end_1, start_1)
        n_2 = torch.sub(end_2, start_2)
        removed_n = torch.add(n_1, n_2)
        use_debug_mode1 = self.use_debug_mode
        if use_debug_mode1:
          if torch.lt(0, n_1):
            size = self.size
            _21 = torch.le(n_1, size)
          else:
            _21 = False
          if _21:
            pass
          else:
            ops.prim.RaiseException("AssertionError: ")
          if torch.le(0, n_2):
            size2 = self.size
            _22 = torch.lt(n_2, size2)
          else:
            _22 = False
          if _22:
            pass
          else:
            ops.prim.RaiseException("AssertionError: ")
          size3 = self.size
          if torch.le(removed_n, size3):
            pass
          else:
            ops.prim.RaiseException("AssertionError: ")
        else:
          pass
        queue4 = self.queue
        _23 = torch.slice(torch.slice(queue4), 1, start_1, end_1)
        _24 = torch.slice(torch.slice(out), 1, 0, n_1)
        _25 = torch.copy_(_24, _23)
        if torch.gt(n_2, 0):
          queue5 = self.queue
          _26 = torch.slice(torch.slice(queue5), 1, start_2, end_2)
          _27 = torch.slice(torch.slice(out), 1, n_1, removed_n)
          _28 = torch.copy_(_27, _26)
        else:
          pass
        self.start_idx = end_2
        size4 = self.size
        self.size = torch.sub(size4, removed_n)
        use_debug_mode2 = self.use_debug_mode
        if use_debug_mode2:
          size5 = self.size
          if torch.eq(size5, 0):
            start_idx = self.start_idx
            end_idx = self.end_idx
            _29 = torch.eq(start_idx, end_idx)
            if _29:
              pass
            else:
              ops.prim.RaiseException("AssertionError: ")
          else:
            pass
        else:
          pass
        _19 = removed_n
      _18 = _19
    return _18
  def push(self: __torch__.neutone_sdk.queues.CircularInplaceTensorQueue,
    x: Tensor) -> NoneType:
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _30 = torch.dim(x)
      queue = self.queue
      if torch.eq(_30, torch.dim(queue)):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _31 = torch.size(x, 0)
      queue6 = self.queue
      _32 = torch.eq(_31, torch.size(queue6, 0))
      if _32:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    in_n = torch.size(x, 1)
    max_size = self.max_size
    if torch.ge(in_n, max_size):
      _33 = torch.slice(x)
      max_size5 = self.max_size
      _34 = torch.slice(_33, 1, torch.neg(max_size5))
      queue7 = self.queue
      _35 = torch.slice(torch.slice(queue7), 1)
      _36 = torch.copy_(_35, _34)
      self.start_idx = 0
      max_size6 = self.max_size
      self.end_idx = max_size6
      max_size7 = self.max_size
      self.size = max_size7
    else:
      if torch.lt(in_n, 1):
        pass
      else:
        _37 = (self)._calc_push_indices(in_n, )
        start_1, end_1, start_2, end_2, = _37
        n_1 = torch.sub(end_1, start_1)
        _38 = torch.slice(torch.slice(x), 1, 0, n_1)
        queue8 = self.queue
        _39 = torch.slice(torch.slice(queue8), 1, start_1, end_1)
        _40 = torch.copy_(_39, _38)
        if torch.lt(n_1, in_n):
          _41 = torch.slice(torch.slice(x), 1, n_1)
          queue9 = self.queue
          _42 = torch.slice(torch.slice(queue9), 1, start_2, end_2)
          _43 = torch.copy_(_42, _41)
        else:
          pass
        self.end_idx = end_2
        size = self.size
        _44 = torch.add(size, in_n)
        max_size8 = self.max_size
        self.size = ops.prim.min(_44, max_size8)
        size6 = self.size
        max_size9 = self.max_size
        if torch.eq(size6, max_size9):
          end_idx = self.end_idx
          self.start_idx = end_idx
        else:
          pass
    return None
  def reset(self: __torch__.neutone_sdk.queues.CircularInplaceTensorQueue) -> NoneType:
    self.start_idx = 0
    self.end_idx = 0
    self.size = 0
    return None
