class ChannelNormalizerSandwich(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  use_debug_mode : bool
  half_scalar : Tensor
  def forward(self: __torch__.neutone_sdk.sandwich.ChannelNormalizerSandwich,
    x: Tensor,
    should_be_mono: bool,
    out_buffer: Tensor) -> Tensor:
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      if torch.eq(torch.dim(x), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      if torch.le(torch.size(x, 0), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _0 = torch.eq(torch.dim(out_buffer), 2)
      if _0:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _1 = torch.eq(torch.size(out_buffer, 0), 2)
      if _1:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _2 = torch.ge(torch.size(out_buffer, 1), torch.size(x, 1))
      if _2:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    n_ch = torch.size(x, 0)
    n_samples = torch.size(x, 1)
    if should_be_mono:
      _3 = torch.eq(n_ch, 2)
    else:
      _3 = False
    if _3:
      out = torch.slice(torch.slice(out_buffer, 0, 0, 1), 1, 0, n_samples)
      _4 = torch.slice(torch.slice(x, 0, 0, 1), 1)
      _5 = torch.slice(torch.slice(x, 0, 1, 2), 1)
      _6 = torch.add(_4, _5, out=out)
      half_scalar = self.half_scalar
      _7 = torch.mul(out, half_scalar, out=out)
      x0 = out
    else:
      if torch.__not__(should_be_mono):
        _8 = torch.eq(n_ch, 1)
      else:
        _8 = False
      if _8:
        _9 = torch.slice(out_buffer, 0, 0, 1)
        _10 = torch.slice(_9, 1, 0, n_samples)
        _11 = torch.copy_(_10, x)
        _12 = torch.slice(out_buffer, 0, 1, 2)
        _13 = torch.slice(_12, 1, 0, n_samples)
        _14 = torch.copy_(_13, x)
        x1 = out_buffer
      else:
        x1 = x
      x0 = x1
    return x0
class InplaceInterpolationResampler(Module):
  __parameters__ = []
  __buffers__ = []
  in_n_ch : int
  out_n_ch : int
  interp_in : Tensor
  floor_in : Tensor
  ceil_in : Tensor
  in_a : Tensor
  in_b : Tensor
  interp_out : Tensor
  floor_out : Tensor
  ceil_out : Tensor
  out_a : Tensor
  out_b : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  use_debug_mode : bool
  in_sr : int
  out_sr : int
  in_bs : int
  out_bs : int
  def process_in(self: __torch__.neutone_sdk.sandwich.InplaceInterpolationResampler,
    x: Tensor) -> Tensor:
    in_n_ch = self.in_n_ch
    in_bs = self.in_bs
    interp_in = self.interp_in
    floor_in = self.floor_in
    ceil_in = self.ceil_in
    in_a = self.in_a
    in_b = self.in_b
    _15 = (self)._process(x, in_n_ch, in_bs, interp_in, floor_in, ceil_in, in_a, in_b, )
    return _15
  def _process(self: __torch__.neutone_sdk.sandwich.InplaceInterpolationResampler,
    x: Tensor,
    n_ch: int,
    in_bs: int,
    interp_t: Tensor,
    floor_t: Tensor,
    ceil_t: Tensor,
    a_t: Tensor,
    b_t: Tensor) -> Tensor:
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _16 = torch.eq(torch.size(x), [n_ch, in_bs])
      if _16:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    _17 = torch.__not__((self).is_resampling())
    if _17:
      _18 = x
    else:
      _19 = torch.index_select(x, 1, floor_t, out=a_t)
      _20 = torch.index_select(x, 1, ceil_t, out=b_t)
      _21 = torch.sub(b_t, a_t, out=b_t)
      _22 = torch.mul(b_t, interp_t, out=b_t)
      _23 = torch.add(a_t, b_t, out=a_t)
      _18 = a_t
    return _18
  def is_resampling(self: __torch__.neutone_sdk.sandwich.InplaceInterpolationResampler) -> bool:
    in_bs = self.in_bs
    out_bs = self.out_bs
    return torch.ne(in_bs, out_bs)
  def process_out(self: __torch__.neutone_sdk.sandwich.InplaceInterpolationResampler,
    x: Tensor) -> Tensor:
    out_n_ch = self.out_n_ch
    out_bs = self.out_bs
    interp_out = self.interp_out
    floor_out = self.floor_out
    ceil_out = self.ceil_out
    out_a = self.out_a
    out_b = self.out_b
    _24 = (self)._process(x, out_n_ch, out_bs, interp_out, floor_out, ceil_out, out_a, out_b, )
    return _24
  def set_sample_rates(self: __torch__.neutone_sdk.sandwich.InplaceInterpolationResampler,
    in_sr: int,
    out_sr: int,
    in_bs: int) -> NoneType:
    self.in_sr = in_sr
    self.out_sr = out_sr
    self.in_bs = in_bs
    in_bs0 = self.in_bs
    out_sr0 = self.out_sr
    _25 = torch.mul(in_bs0, out_sr0)
    in_sr0 = self.in_sr
    self.out_bs = torch.ceil(torch.div(_25, in_sr0))
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      out_bs = self.out_bs
      if torch.ge(out_bs, 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    in_bs1 = self.in_bs
    _26 = torch.sub(in_bs1, 1)
    out_bs0 = self.out_bs
    scaling_factor_in = torch.div(_26, torch.sub(out_bs0, 1))
    _27 = annotate(List[float], [])
    out_bs1 = self.out_bs
    for _28 in range(out_bs1):
      _29 = torch.append(_27, float(_28))
    interp_in = torch.mul(torch.tensor(_27), scaling_factor_in)
    floor_in = torch.to(torch.floor(interp_in), 4)
    in_bs2 = self.in_bs
    _30 = torch.clamp(floor_in, 0, torch.sub(in_bs2, 1))
    self.floor_in = _30
    ceil_in = torch.to(torch.ceil(interp_in), 4)
    in_bs3 = self.in_bs
    _31 = torch.clamp(ceil_in, 0, torch.sub(in_bs3, 1))
    self.ceil_in = _31
    floor_in0 = self.floor_in
    _32 = torch.clamp(torch.sub(interp_in, floor_in0), 0., 1.)
    self.interp_in = _32
    in_n_ch = self.in_n_ch
    out_bs2 = self.out_bs
    self.in_a = torch.zeros([in_n_ch, out_bs2])
    in_n_ch0 = self.in_n_ch
    out_bs3 = self.out_bs
    self.in_b = torch.zeros([in_n_ch0, out_bs3])
    out_bs4 = self.out_bs
    _33 = torch.sub(out_bs4, 1)
    in_bs4 = self.in_bs
    scaling_factor_out = torch.div(_33, torch.sub(in_bs4, 1))
    _34 = annotate(List[float], [])
    in_bs5 = self.in_bs
    for _35 in range(in_bs5):
      _36 = torch.append(_34, float(_35))
    interp_out = torch.mul(torch.tensor(_34), scaling_factor_out)
    floor_out = torch.to(torch.floor(interp_out), 4)
    out_bs5 = self.out_bs
    _37 = torch.clamp(floor_out, 0, torch.sub(out_bs5, 1))
    self.floor_out = _37
    ceil_out = torch.to(torch.ceil(interp_out), 4)
    out_bs6 = self.out_bs
    _38 = torch.clamp(ceil_out, 0, torch.sub(out_bs6, 1))
    self.ceil_out = _38
    floor_out0 = self.floor_out
    _39 = torch.clamp(torch.sub(interp_out, floor_out0), 0., 1.)
    self.interp_out = _39
    out_n_ch = self.out_n_ch
    in_bs6 = self.in_bs
    self.out_a = torch.zeros([out_n_ch, in_bs6])
    out_n_ch0 = self.out_n_ch
    in_bs7 = self.in_bs
    self.out_b = torch.zeros([out_n_ch0, in_bs7])
    return None
