class SampleQueueWrapper(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  use_debug_mode : bool
  in_n_ch : int
  out_n_ch : int
  daw_sr : int
  model_sr : int
  daw_bs : int
  io_bs : int
  model_bs : int
  seen_n : int
  is_queue_saturated : bool
  saturation_n : int
  in_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  params_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  out_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  daw_buffer : Tensor
  model_in_buffer : Tensor
  params_buffer : Tensor
  io_out_buffer : Tensor
  bt_out_buffer : Tensor
  w2w_base : __torch__.EffectModelWrapper
  channel_normalizer : __torch__.neutone_sdk.sandwich.ChannelNormalizerSandwich
  resample_sandwich : __torch__.neutone_sdk.sandwich.InplaceInterpolationResampler
  params_resample_sandwich : __torch__.neutone_sdk.sandwich.InplaceInterpolationResampler
  def forward(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper,
    x: Tensor,
    params: Optional[Tensor]=None) -> Tensor:
    is_daw_mono = torch.eq(torch.size(x, 0), 1)
    in_n = (torch.size(x))[1]
    channel_normalizer = self.channel_normalizer
    _0 = (self).is_input_mono()
    daw_buffer = self.daw_buffer
    x0 = (channel_normalizer).forward(x, _0, daw_buffer, )
    resample_sandwich = self.resample_sandwich
    x1 = (resample_sandwich).process_in(x0, )
    _1 = (self)._forward(x1, params, )
    is_queue_saturated = self.is_queue_saturated
    if is_queue_saturated:
      out_queue = self.out_queue
      io_out_buffer = self.io_out_buffer
      out_popped_n = (out_queue).pop(io_out_buffer, )
    else:
      io_out_buffer0 = self.io_out_buffer
      out_popped_n0 = torch.size(io_out_buffer0, 1)
      io_out_buffer1 = self.io_out_buffer
      _2 = torch.fill_(io_out_buffer1, 0)
      out_popped_n = out_popped_n0
    resample_sandwich0 = self.resample_sandwich
    io_out_buffer2 = self.io_out_buffer
    x2 = (resample_sandwich0).process_out(io_out_buffer2, )
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      io_out_buffer3 = self.io_out_buffer
      _3 = torch.eq(out_popped_n, torch.size(io_out_buffer3, 1))
      if _3:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      if torch.eq(torch.size(x2, 1), in_n):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    channel_normalizer0 = self.channel_normalizer
    daw_buffer0 = self.daw_buffer
    x3 = (channel_normalizer0).forward(x2, is_daw_mono, daw_buffer0, )
    return x3
  def calc_buffering_delay_samples(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> int:
    _4 = __torch__.neutone_sdk.sqw.calc_delay_samples
    io_bs = self.io_bs
    model_bs = self.model_bs
    delay_samples = _4(io_bs, model_bs, )
    if (self).is_resampling():
      daw_bs = self.daw_bs
      _5 = torch.mul(delay_samples, daw_bs)
      io_bs0 = self.io_bs
      delay_samples0 = int(torch.div(_5, io_bs0))
    else:
      delay_samples0 = delay_samples
    return delay_samples0
  def calc_model_delay_samples(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> int:
    w2w_base = self.w2w_base
    delay_samples = (w2w_base).calc_model_delay_samples()
    if (self).is_resampling():
      daw_bs = self.daw_bs
      _6 = torch.mul(delay_samples, daw_bs)
      io_bs = self.io_bs
      delay_samples1 = int(torch.div(_6, io_bs))
    else:
      delay_samples1 = delay_samples
    return delay_samples1
  def forward_bt(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper,
    x: Tensor,
    params: Optional[Tensor]=None) -> Optional[Tensor]:
    daw_n_ch = torch.size(x, 0)
    is_daw_mono = torch.eq(daw_n_ch, 1)
    channel_normalizer = self.channel_normalizer
    _7 = (self).is_input_mono()
    daw_buffer = self.daw_buffer
    x4 = (channel_normalizer).forward(x, _7, daw_buffer, )
    resample_sandwich = self.resample_sandwich
    x5 = (resample_sandwich).process_in(x4, )
    _8 = (self)._forward(x5, params, )
    is_queue_saturated = self.is_queue_saturated
    if is_queue_saturated:
      out_queue = self.out_queue
      size = out_queue.size
      io_bs = self.io_bs
      _9 = torch.ge(size, io_bs)
    else:
      _9 = False
    curr_n = 0
    _10 = _9
    while _10:
      out_queue0 = self.out_queue
      io_out_buffer = self.io_out_buffer
      out_popped_n = (out_queue0).pop(io_out_buffer, )
      use_debug_mode = self.use_debug_mode
      if use_debug_mode:
        io_bs1 = self.io_bs
        if torch.eq(out_popped_n, io_bs1):
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
      else:
        pass
      resample_sandwich1 = self.resample_sandwich
      io_out_buffer4 = self.io_out_buffer
      x6 = (resample_sandwich1).process_out(io_out_buffer4, )
      channel_normalizer1 = self.channel_normalizer
      daw_buffer1 = self.daw_buffer
      x7 = (channel_normalizer1).forward(x6, is_daw_mono, daw_buffer1, )
      use_debug_mode0 = self.use_debug_mode
      if use_debug_mode0:
        _11 = torch.size(x7, 1)
        daw_bs = self.daw_bs
        if torch.eq(_11, daw_bs):
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
        daw_bs0 = self.daw_bs
        _12 = torch.add(curr_n, daw_bs0)
        bt_out_buffer = self.bt_out_buffer
        _13 = torch.le(_12, torch.size(bt_out_buffer, 1))
        if _13:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
      else:
        pass
      bt_out_buffer0 = self.bt_out_buffer
      _14 = torch.slice(bt_out_buffer0, 0, 0, daw_n_ch)
      daw_bs1 = self.daw_bs
      _15 = torch.slice(_14, 1, curr_n, torch.add(curr_n, daw_bs1))
      _16 = torch.copy_(_15, x7)
      daw_bs2 = self.daw_bs
      curr_n0 = torch.add(curr_n, daw_bs2)
      is_queue_saturated0 = self.is_queue_saturated
      if is_queue_saturated0:
        out_queue1 = self.out_queue
        size0 = out_queue1.size
        io_bs2 = self.io_bs
        _17 = torch.ge(size0, io_bs2)
      else:
        _17 = False
      _10, curr_n = _17, curr_n0
    if torch.eq(curr_n, 0):
      _18 : Optional[Tensor] = None
    else:
      bt_out_buffer1 = self.bt_out_buffer
      _19 = torch.slice(bt_out_buffer1, 0, 0, daw_n_ch)
      _18 = torch.slice(_19, 1, 0, curr_n)
    return _18
  def get_default_param_descriptions(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[str]:
    w2w_base = self.w2w_base
    _20 = (w2w_base).get_default_param_descriptions()
    return _20
  def get_default_param_names(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[str]:
    w2w_base = self.w2w_base
    _21 = (w2w_base).get_default_param_names()
    return _21
  def get_default_param_types(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[str]:
    w2w_base = self.w2w_base
    _22 = (w2w_base).get_default_param_types()
    return _22
  def get_default_param_used(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[bool]:
    w2w_base = self.w2w_base
    return (w2w_base).get_default_param_used()
  def get_default_param_values(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> Tensor:
    w2w_base = self.w2w_base
    _23 = (w2w_base).get_default_param_values()
    return _23
  def get_dry_default_value(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> float:
    w2w_base = self.w2w_base
    return (w2w_base).get_dry_default_value()
  def get_input_gain_default_value(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> float:
    w2w_base = self.w2w_base
    _24 = (w2w_base).get_input_gain_default_value()
    return _24
  def get_model_authors(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[str]:
    w2w_base = self.w2w_base
    return (w2w_base).get_model_authors()
  def get_model_name(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> str:
    w2w_base = self.w2w_base
    return (w2w_base).get_model_name()
  def get_native_buffer_sizes(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[int]:
    w2w_base = self.w2w_base
    _25 = (w2w_base).get_native_buffer_sizes()
    return _25
  def get_native_sample_rates(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[int]:
    w2w_base = self.w2w_base
    _26 = (w2w_base).get_native_sample_rates()
    return _26
  def get_output_gain_default_value(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> float:
    w2w_base = self.w2w_base
    _27 = (w2w_base).get_output_gain_default_value()
    return _27
  def get_preserved_attributes(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[str]:
    _28 = "set_daw_sample_rate_and_buffer_size"
    _29 = ["forward_bt", "is_input_mono", "is_output_mono", "get_model_name", "get_model_authors", "get_native_sample_rates", "get_native_buffer_sizes", "get_wet_default_value", "get_dry_default_value", "get_default_param_values", "get_input_gain_default_value", "get_output_gain_default_value", "is_resampling", "calc_buffering_delay_samples", "calc_model_delay_samples", _28, "reset", "get_preserved_attributes", "to_metadata", "w2w_base"]
    return _29
  def get_wet_default_value(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> float:
    w2w_base = self.w2w_base
    return (w2w_base).get_wet_default_value()
  def is_input_mono(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> bool:
    w2w_base = self.w2w_base
    return (w2w_base).is_input_mono()
  def is_output_mono(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> bool:
    w2w_base = self.w2w_base
    return (w2w_base).is_output_mono()
  def is_resampling(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> bool:
    resample_sandwich = self.resample_sandwich
    return (resample_sandwich).is_resampling()
  def reset(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> NoneType:
    w2w_base = self.w2w_base
    _30 = (w2w_base).reset()
    in_queue = self.in_queue
    _31 = (in_queue).reset()
    params_queue = self.params_queue
    _32 = (params_queue).reset()
    out_queue = self.out_queue
    _33 = (out_queue).reset()
    daw_buffer = self.daw_buffer
    _34 = torch.fill_(daw_buffer, 0)
    model_in_buffer = self.model_in_buffer
    _35 = torch.fill_(model_in_buffer, 0)
    params_buffer = self.params_buffer
    _36 = torch.fill_(params_buffer, 0)
    io_out_buffer = self.io_out_buffer
    _37 = torch.fill_(io_out_buffer, 0)
    bt_out_buffer = self.bt_out_buffer
    _38 = torch.fill_(bt_out_buffer, 0)
    self.seen_n = 0
    self.is_queue_saturated = False
    return None
  def set_daw_sample_rate_and_buffer_size(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper,
    daw_sr: int,
    daw_bs: int,
    model_sr: Optional[int]=None,
    model_bs: Optional[int]=None) -> int:
    _39 = __torch__.neutone_sdk.sqw.select_best_model_sr
    _40 = __torch__.neutone_sdk.sqw.calc_resampled_buffer_size
    _41 = __torch__.neutone_sdk.sqw.select_best_model_buffer_size
    _42 = __torch__.neutone_sdk.sqw.calc_max_daw_queue_size
    _43 = __torch__.neutone_sdk.sqw.calc_saturation_n
    if torch.__isnot__(model_sr, None):
      model_sr1 = unchecked_cast(int, model_sr)
      use_debug_mode = self.use_debug_mode
      if use_debug_mode:
        _44 = (self).get_native_sample_rates()
        if torch.eq(torch.len(_44), 0):
          _45 = True
        else:
          _46 = (self).get_native_sample_rates()
          _47 = torch.__contains__(_46, model_sr1)
          _45 = _47
        if _45:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
      else:
        pass
      model_sr0 = model_sr1
    else:
      model_sr2 = _39(daw_sr, (self).get_native_sample_rates(), )
      model_sr0 = model_sr2
    io_bs = _40(daw_sr, model_sr0, daw_bs, )
    resample_sandwich = self.resample_sandwich
    _48 = (resample_sandwich).set_sample_rates(daw_sr, model_sr0, daw_bs, )
    params_resample_sandwich = self.params_resample_sandwich
    _49 = (params_resample_sandwich).set_sample_rates(daw_sr, model_sr0, daw_bs, )
    self.daw_sr = daw_sr
    self.model_sr = model_sr0
    if torch.__isnot__(model_bs, None):
      model_bs1 = unchecked_cast(int, model_bs)
      use_debug_mode1 = self.use_debug_mode
      if use_debug_mode1:
        _50 = (self).get_native_buffer_sizes()
        if torch.eq(torch.len(_50), 0):
          _51 = True
        else:
          _52 = (self).get_native_buffer_sizes()
          _53 = torch.__contains__(_52, model_bs1)
          _51 = _53
        if _51:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
      else:
        pass
      model_bs0 = model_bs1
    else:
      model_bs2 = _41(io_bs, (self).get_native_buffer_sizes(), )
      model_bs0 = model_bs2
    w2w_base = self.w2w_base
    _54 = (w2w_base).set_sample_rate_and_buffer_size(model_sr0, model_bs0, )
    self.daw_bs = daw_bs
    self.io_bs = io_bs
    self.model_bs = model_bs0
    in_n_ch = self.in_n_ch
    io_bs3 = self.io_bs
    _55 = torch.mul(2, io_bs3)
    model_bs3 = self.model_bs
    _56 = torch.add(_55, model_bs3)
    use_debug_mode2 = self.use_debug_mode
    _57 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
    _58 = (_57).__init__(in_n_ch, _56, use_debug_mode2, )
    self.in_queue = _57
    w2w_base0 = self.w2w_base
    MAX_N_PARAMS = w2w_base0.MAX_N_PARAMS
    io_bs4 = self.io_bs
    _59 = torch.mul(2, io_bs4)
    model_bs4 = self.model_bs
    _60 = torch.add(_59, model_bs4)
    use_debug_mode3 = self.use_debug_mode
    _61 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
    _62 = (_61).__init__(MAX_N_PARAMS, _60, use_debug_mode3, )
    self.params_queue = _61
    out_n_ch = self.out_n_ch
    io_bs5 = self.io_bs
    _63 = torch.mul(2, io_bs5)
    model_bs5 = self.model_bs
    _64 = torch.add(_63, model_bs5)
    use_debug_mode4 = self.use_debug_mode
    _65 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
    _66 = (_65).__init__(out_n_ch, _64, use_debug_mode4, )
    self.out_queue = _65
    daw_bs3 = self.daw_bs
    self.daw_buffer = torch.zeros([2, daw_bs3])
    in_n_ch0 = self.in_n_ch
    model_bs6 = self.model_bs
    self.model_in_buffer = torch.zeros([in_n_ch0, model_bs6])
    w2w_base1 = self.w2w_base
    MAX_N_PARAMS0 = w2w_base1.MAX_N_PARAMS
    model_bs7 = self.model_bs
    _67 = torch.zeros([MAX_N_PARAMS0, model_bs7])
    self.params_buffer = _67
    out_n_ch0 = self.out_n_ch
    io_bs6 = self.io_bs
    self.io_out_buffer = torch.zeros([out_n_ch0, io_bs6])
    daw_sr0 = self.daw_sr
    daw_bs4 = self.daw_bs
    model_sr3 = self.model_sr
    model_bs8 = self.model_bs
    max_daw_queue_size = _42(daw_sr0, daw_bs4, model_sr3, model_bs8, )
    _68 = torch.zeros([2, max_daw_queue_size])
    self.bt_out_buffer = _68
    io_bs7 = self.io_bs
    model_bs9 = self.model_bs
    self.saturation_n = _43(io_bs7, model_bs9, )
    _69 = (self).reset()
    return max_daw_queue_size
  def to_metadata(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> __torch__.neutone_sdk.wavform_to_wavform.WaveformToWaveformMetadata:
    w2w_base = self.w2w_base
    return (w2w_base).to_metadata()
  def _forward(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper,
    resampled_x: Tensor,
    params: Optional[Tensor]=None) -> NoneType:
    _70 = __torch__.neutone_sdk.utils.validate_waveform
    if torch.__isnot__(params, None):
      params0 = unchecked_cast(Tensor, params)
      params_resample_sandwich = self.params_resample_sandwich
      params1 = (params_resample_sandwich).process_in(params0, )
      params_queue = self.params_queue
      _71 = (params_queue).push(params1, )
    else:
      pass
    resampled_in_n = torch.size(resampled_x, 1)
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      io_bs = self.io_bs
      if torch.eq(resampled_in_n, io_bs):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    in_queue = self.in_queue
    _72 = (in_queue).push(resampled_x, )
    is_queue_saturated = self.is_queue_saturated
    if torch.__not__(is_queue_saturated):
      seen_n = self.seen_n
      self.seen_n = torch.add(seen_n, resampled_in_n)
      seen_n0 = self.seen_n
      saturation_n = self.saturation_n
      if torch.ge(seen_n0, saturation_n):
        self.is_queue_saturated = True
      else:
        pass
    else:
      pass
    in_queue0 = self.in_queue
    size = in_queue0.size
    model_bs = self.model_bs
    _73 = torch.ge(size, model_bs)
    while _73:
      in_queue1 = self.in_queue
      model_in_buffer = self.model_in_buffer
      in_popped_n = (in_queue1).pop(model_in_buffer, )
      use_debug_mode5 = self.use_debug_mode
      if use_debug_mode5:
        model_bs7 = self.model_bs
        _74 = torch.eq(in_popped_n, model_bs7)
        if _74:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
        model_in_buffer0 = self.model_in_buffer
        _75 = _70(model_in_buffer0, (self).is_input_mono(), )
      else:
        pass
      params_queue0 = self.params_queue
      if (params_queue0).is_empty():
        w2w_base = self.w2w_base
        model_in_buffer1 = self.model_in_buffer
        model_out0 = (w2w_base).forward(model_in_buffer1, None, )
        model_out = model_out0
      else:
        params_queue1 = self.params_queue
        params_buffer = self.params_buffer
        params_popped_n = (params_queue1).pop(params_buffer, )
        use_debug_mode6 = self.use_debug_mode
        if use_debug_mode6:
          _76 = torch.eq(params_popped_n, in_popped_n)
          if _76:
            pass
          else:
            ops.prim.RaiseException("AssertionError: ")
        else:
          pass
        w2w_base2 = self.w2w_base
        model_in_buffer2 = self.model_in_buffer
        params_buffer0 = self.params_buffer
        model_out1 = (w2w_base2).forward(model_in_buffer2, params_buffer0, )
        model_out = model_out1
      use_debug_mode7 = self.use_debug_mode
      if use_debug_mode7:
        _77 = _70(model_out, (self).is_output_mono(), )
      else:
        pass
      out_queue = self.out_queue
      _78 = (out_queue).push(model_out, )
      in_queue2 = self.in_queue
      size1 = in_queue2.size
      model_bs8 = self.model_bs
      _73 = torch.ge(size1, model_bs8)
    return None
def calc_delay_samples(io_bs: int,
    model_bs: int) -> int:
  _79 = __torch__.neutone_sdk.sqw.calc_saturation_n
  saturation_n = _79(io_bs, model_bs, )
  return torch.sub(saturation_n, io_bs)
def select_best_model_sr(daw_sr: int,
    native_sample_rates: List[int]) -> int:
  _80 = torch.gt(torch.len(native_sample_rates), 0)
  if torch.__not__(_80):
    _81 = daw_sr
  else:
    _82 = torch.__contains__(native_sample_rates, daw_sr)
    if _82:
      _83 = daw_sr
    else:
      _84 = torch.eq(torch.len(native_sample_rates), 1)
      if _84:
        _85 = native_sample_rates[0]
      else:
        diffs = annotate(List[int], [])
        for _86 in range(torch.len(native_sample_rates)):
          sr = native_sample_rates[_86]
          _87 = ops.prim.abs(torch.sub(sr, daw_sr))
          _88 = torch.append(diffs, _87)
        min_idx = torch.index(diffs, ops.prim.min(diffs))
        _85 = native_sample_rates[min_idx]
      _83 = _85
    _81 = _83
  return _81
def calc_resampled_buffer_size(orig_sr: int,
    new_sr: int,
    orig_bs: int) -> int:
  if torch.eq(orig_sr, new_sr):
    resampled_bs = orig_bs
  else:
    _89 = torch.div(torch.mul(new_sr, orig_bs), orig_sr)
    resampled_bs = torch.ceil(_89)
  return resampled_bs
def select_best_model_buffer_size(io_bs: int,
    native_buffer_sizes: List[int]) -> int:
  _90 = uninitialized(int)
  _91 = torch.gt(torch.len(native_buffer_sizes), 0)
  if torch.__not__(_91):
    _92 = io_bs
  else:
    _93 = torch.eq(torch.len(native_buffer_sizes), 1)
    if _93:
      _94 = native_buffer_sizes[0]
    else:
      native_buffer_sizes0 = sorted(native_buffer_sizes)
      _95 = torch.len(native_buffer_sizes0)
      _96 = False
      _97 = _90
      _98 = 0
      _99 = torch.gt(_95, 0)
      while _99:
        bs = native_buffer_sizes0[_98]
        _100 = torch.eq(torch.remainder(bs, io_bs), 0)
        if _100:
          _101, _102, _103 = False, True, bs
        else:
          _101, _102, _103 = True, False, _90
        _104 = torch.add(_98, 1)
        _105 = torch.__and__(torch.lt(_104, _95), _101)
        _99, _96, _97, _98 = _105, _102, _103, _104
      if _96:
        _106 = _97
      else:
        _107 = torch.len(native_buffer_sizes0)
        _108 = False
        _109 = _90
        _110 = 0
        _111 = torch.gt(_107, 0)
        while _111:
          bs0 = native_buffer_sizes0[_110]
          if torch.gt(bs0, io_bs):
            _112, _113, _114 = False, True, bs0
          else:
            _112, _113, _114 = True, False, _90
          _115 = torch.add(_110, 1)
          _116 = torch.__and__(torch.lt(_115, _107), _112)
          _111, _108, _109, _110 = _116, _113, _114, _115
        if _108:
          _117 = _109
        else:
          diffs = annotate(List[int], [])
          _118 = torch.len(native_buffer_sizes0)
          for _119 in range(_118):
            bs1 = native_buffer_sizes0[_119]
            _120 = ops.prim.abs(torch.sub(bs1, io_bs))
            _121 = torch.append(diffs, _120)
          min_idx = torch.index(diffs, ops.prim.min(diffs))
          _117 = native_buffer_sizes0[min_idx]
        _106 = _117
      _94 = _106
    _92 = _94
  return _92
def calc_max_daw_queue_size(daw_sr: int,
    daw_bs: int,
    model_sr: int,
    model_bs: int) -> int:
  _122 = torch.div(torch.mul(model_bs, daw_sr), model_sr)
  daw_model_bs = torch.add(int(_122), 1)
  _123 = torch.add(torch.mul(2, daw_bs), daw_model_bs)
  return _123
def calc_saturation_n(io_bs: int,
    model_bs: int) -> int:
  _124 = __torch__.neutone_sdk.sqw._calc_saturation_n_case_3
  _125 = torch.eq(torch.remainder(model_bs, io_bs), 0)
  if _125:
    _126 = model_bs
  else:
    _127 = torch.eq(torch.remainder(io_bs, model_bs), 0)
    if _127:
      _128 = io_bs
    else:
      if torch.lt(io_bs, model_bs):
        _129 = _124(io_bs, model_bs, )
      else:
        multiplier = torch.floordiv(io_bs, model_bs)
        _130 = torch.mul(multiplier, model_bs)
        _131 = torch.remainder(io_bs, model_bs)
        n = torch.add(_130, _131)
        _132 = torch.add(torch.floordiv(n, io_bs), 1)
        _129 = torch.mul(_132, io_bs)
      _128 = _129
    _126 = _128
  return _126
def _calc_saturation_n_case_3(io_bs: int,
    model_bs: int) -> int:
  io_bs_t = torch.tensor(io_bs)
  model_bs_t = torch.tensor(model_bs)
  lcm_t = torch.lcm(io_bs_t, model_bs_t)
  _133 = torch.div(lcm_t, io_bs_t, rounding_mode="trunc")
  cycle_len = int(torch.item(_133))
  _134 = torch.mul(torch.arange(0, cycle_len, dtype=3), io_bs_t)
  remainders_shifted = torch.remainder(_134, model_bs_t)
  _135 = torch.arange(1, torch.add(cycle_len, 1), dtype=3)
  remainders = torch.remainder(torch.mul(_135, io_bs_t), model_bs_t)
  _136 = torch.gt(remainders, remainders_shifted)
  pop_locs = torch.where(_136, 0, 1)
  pop_locs_rev = torch.flip(pop_locs, [0])
  pop_locs_cumsum = torch.cumsum(pop_locs, 0)
  pop_locs_rev_cumsum = torch.cumsum(pop_locs_rev, 0)
  offset = 0
  _137 = 0
  _138 = torch.gt(cycle_len, 0)
  while _138:
    pop_locs_rev_cumsum_shifted = torch.zeros_like(pop_locs_rev_cumsum)
    _139 = torch.slice(pop_locs_rev_cumsum, 0, 0, torch.sub(cycle_len, offset))
    _140 = torch.slice(pop_locs_rev_cumsum_shifted, 0, offset)
    _141 = torch.copy_(_140, _139)
    _142 = torch.ge(pop_locs_cumsum, pop_locs_rev_cumsum_shifted)
    if bool(torch.all(_142)):
      _143, _144 = False, offset
    else:
      _143, _144 = True, torch.add(offset, 1)
    _145 = torch.add(_137, 1)
    _146 = torch.__and__(torch.lt(_145, cycle_len), _143)
    _138, offset, _137 = _146, _144, _145
  _147 = torch.mul(torch.add(offset, 1), io_bs)
  return _147
